# Copyright (C) 1999 by Juergen Pfeifer
# Ada for Linux Team (ALT)
#
# Permission is hereby granted, free of charge, to any person obtaining a  
# copy of this software and associated documentation files (the            
# "Software"), to deal in the Software without restriction, including      
# without limitation the rights to use, copy, modify, merge, publish,      
# distribute, distribute with modifications, sublicense, and/or sell       
# copies of the Software, and to permit persons to whom the Software is    
# furnished to do so, subject to the following conditions:                 
#                                                                          
# The above copyright notice and this permission notice shall be included  
# in all copies or substantial portions of the Software.                   
#                                                                          
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS  
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF               
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.   
# IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,   
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR    
# OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR    
# THE USE OR OTHER DEALINGS IN THE SOFTWARE.                               
#                                                                          
# Except as contained in this notice, the name(s) of the above copyright   
# holders shall not be used in advertising or otherwise to promote the     
# sale, use or other dealings in this Software without prior written       
# authorization.          
#
# ---------------------------------------------------------------------------
#  Author: Jrgen Pfeifer <Juergen.Pfeifer@T-Online.de>
# ---------------------------------------------------------------------------
#
# GNU Ada RPM Packaging for aflex and ayacc
#
%define        GNAT_TARGET_ARCH    i386
%define        COMPAT_TARGET_ARCH  i386 i486 i586 i686
%define        GNAT_TARGET_OS      Linux
%define        TARGET_OS           linux 
#
%define        BASE_NAME           gnat
%define        GNAT_PKG_NAME       gnat-3.11p
%define        GNAT_VERSION        3.11p
%define        GNAT_PKG_VERSION    1
%define        GNAT_PKG_RELEASE    10
%define        GCC_VERSION         2.8.1
%define        GDB_VERSION         4.17
#
%define        DEF_USER       bin
%define        DEF_GROUP      bin
#
%define        BASE_VERSION   gcc-%{GCC_VERSION}
#
%define        CFG_PREFIX     /usr
%define        ADA_ROOT       /lib/gnat
%define        ADA_BASE       %{CFG_PREFIX}%{ADA_ROOT}
#
%define        GNAT_SO_MAJOR  %{GNAT_PKG_VERSION}
%define        GNAT_SO_MINOR  %{GNAT_PKG_RELEASE}
#
%define        RPM_C_FLAGS     -O3 -m486 -fomit-frame-pointer
%define        RPM_ADA_FLAGS   -gnatpn
#
%define        THREADLIBS     -lpthread
#
%define        GNAT_NAME      gnat-%{GNAT_VERSION}
%define        GNAT_SO        %{GNAT_NAME}
%define        GNAT_DIR       %{ADA_BASE}/%{GNAT_NAME}
#
%define        AINC_NAME      adainclude
%define        AINC_DIR       %{ADA_BASE}/%{AINC_NAME}
#
%define        ALIB_NAME      adalib
%define        ALIB_DIR       %{ADA_BASE}/%{ALIB_NAME}
#
%define        ETC_NAME       etc
%define        ETC_DIR        %{ADA_BASE}/%{ETC_NAME}
#
%define        COMPAT_NAME    act_compat-%{GNAT_VERSION}
%define        COMPAT_DIR     %{ADA_BASE}/%{COMPAT_NAME}
#
%define        ASIS_NAME      asis-%{GNAT_VERSION}
%define        ASIS_SO        %{ASIS_NAME}
%define        ASIS_DIR       %{ADA_BASE}/%{ASIS_NAME}
#
%define        GLADE_NAME     glade-%{GNAT_VERSION}
%define        GLADE_DIR      %{ADA_BASE}/%{GLADE_NAME}
#dnl
#
%define        PKG_NAME       aflex_ayacc
%define        PKG_VERSION    1.4a
%define        PKG_RELEASE    3
#
# ---------------------------------------------------------------------------
# We restrict the use of this package scipt at the moment to Intel and Linux.
# For sure there are details (compiler options, shared library building)
# that must be fixed for other architectures and OSes.
#
ExclusiveArch: %{COMPAT_TARGET_ARCH}
ExclusiveOS:   %{GNAT_TARGET_OS}
Packager:      Jrgen Pfeifer <Juergen.Pfeifer@t-online.de>
Distribution:  ALT (Ada for Linux Team)
Version:       %{PKG_VERSION}
Release:       %{PKG_RELEASE}
Name:          %{PKG_NAME}
BuildRoot:     /var/tmp/%{PKG_NAME}-%{version}-root
Autoreq:       No
Autoreqprov:   No
# ---------------------------------------------------------------------------
# This are the official sources
Source0:       ftp://liege.ics.uci.edu/pub/irus/software_releases/aflex-ayacc_1.4a.tar.Z
Source1:       README.afay
#
# This is our patch
Patch0:        afay_14a.diff
#
#  ---------------------------------------------------------------------------
Copyright:     BSD like
Summary:       Ada for Linux Team (ALT) aflex and ayacc port.
Summary(de):   Ada fr Linux Teams (ALT) Portierung von aflex und ayacc.
Group:         Development/Languages
Requires:      %{GNAT_PKG_NAME}-devel >= %{GNAT_PKG_VERSION}
Obsoletes:     %{name}
Icon:          adasmall.gif
Prefix:        %{CFG_PREFIX}
#
%description
This is the Ada for Linux Team adaption of the aflex and ayacc tools.
These tools are implementations of the popular flex and yacc tools that
produce Ada code instead of C.
#
%description -l de
Dies ist die vom Ada fr Linux Team vorgenommene Adaption der aflex und ayacc
Tools. Diese Tools sind Implementierungen der populren flex und yacc tools die
anstelle von C Code Ada Code produzieren.
#
#-----------------------------------------------------------------------------
%prep
#=============================================================================
#
%setup -c -q  -n afay
%patch0 -p1 -b .afay
#
#-----------------------------------------------------------------------------
%build
#=============================================================================
# Create the required directory structure for the binary package
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/bin
mkdir -p $RPM_BUILD_ROOT/usr/doc
mkdir -p $RPM_BUILD_ROOT/doc/aflex
mkdir -p $RPM_BUILD_ROOT/doc/aflex/example
mkdir -p $RPM_BUILD_ROOT/doc/ayacc

for f in aflex ayacc
do
  cd ${f}/src
  for g in *.a
  do
    gnatchop -w ${g}
  done
  gnatmake -v %{RPM_C_FLAGS} %{RPM_ADA_FLAGS} ${f} -bargs -A -largs -A
  cd ../doc
  latex ${f}_user_man
  if [ "${f}" = "aflex" ]; then
    bibtex ${f}_user_man
  fi
  latex ${f}_user_man
  dvips -o ${f}_user_man.ps ${f}_user_man
  cd ../..
done
#
#-----------------------------------------------------------------------------
%install
#=============================================================================
OS=%{TARGET_OS}
#
for f in aflex ayacc
do
  cp -pf ${f}/src/${f} ${RPM_BUILD_ROOT}%{CFG_PREFIX}/bin/${f}
  strip ${RPM_BUILD_ROOT}%{CFG_PREFIX}/bin/${f}
  chmod 0755 ${RPM_BUILD_ROOT}%{CFG_PREFIX}/bin/${f}
done
#
cp README $RPM_BUILD_ROOT/doc
cp $RPM_SOURCE_DIR/README.afay $RPM_BUILD_ROOT/doc/README.ALT
#
cd aflex
cp -pf README                 $RPM_BUILD_ROOT/doc/aflex
cp -pf RELEASE.NOTES          $RPM_BUILD_ROOT/doc/aflex
cp -pf PORTING                $RPM_BUILD_ROOT/doc/aflex
cp -pf VADS6.README           $RPM_BUILD_ROOT/doc/aflex
cp -pf doc/aflex_user_man.ps  $RPM_BUILD_ROOT/doc/aflex
cp -pf doc/example.l          $RPM_BUILD_ROOT/doc/aflex/example
cp -pf doc/Makefile           $RPM_BUILD_ROOT/doc/aflex/example
cp -pf doc/sample.adb         $RPM_BUILD_ROOT/doc/aflex/example
cd ..
#
cd ayacc
rm -f `find examples -type f -name '*.afay'`
cp -pf README                 $RPM_BUILD_ROOT/doc/ayacc
cp -pf CHANGES*               $RPM_BUILD_ROOT/doc/ayacc
cp -pf doc/ayacc_user_man.ps  $RPM_BUILD_ROOT/doc/ayacc
cp -prf examples              $RPM_BUILD_ROOT/doc/ayacc
cd ..
#
if [ -d ${RPM_BUILD_ROOT}%{AINC_DIR} ]; then
  find ${RPM_BUILD_ROOT}%{AINC_DIR} -type f -name '*.ad?' -exec chmod 0444 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}%{ALIB_DIR} ]; then
  find ${RPM_BUILD_ROOT}%{ALIB_DIR} -type f -name '*.ali' -exec chmod 0444 {} \;
  find ${RPM_BUILD_ROOT}%{ALIB_DIR} -type f -name '*.a'   -exec chmod 0444 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}%{CFG_PREFIX}/lib ]; then
  find ${RPM_BUILD_ROOT}%{CFG_PREFIX}/lib -type f -name '*.so*' -exec chmod 0755 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}/doc ]; then
  find ${RPM_BUILD_ROOT}/doc -type f -exec chmod 0444 {} \;
  find ${RPM_BUILD_ROOT}/doc -type d -exec chmod 0755 {} \;
fi
#  ---------------------------------------------------------------------------
%pre
if [ -f /etc/profile.d/%{BASE_NAME}-rts.sh ]; then
  source /etc/profile.d/%{BASE_NAME}-rts.sh
  if [ ! -z ${GNAT_ROOT} ]; then
    if [ "${GNAT_ROOT}" != "${RPM_INSTALL_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed with --prefix=${GNAT_ROOT}" >&2
      echo "You must use the same prefix with this package." >&2
      exit 1
    fi
  else
    if [ "${RPM_INSTALL_PREFIX}" != "%{CFG_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed without the --prefix option." >&2
      echo "You must do this also with this package." >&2
      exit 1
    fi
  fi
fi
#  ---------------------------------------------------------------------------
%post
#  ---------------------------------------------------------------------------
%preun
#  ---------------------------------------------------------------------------
%postun
#  ---------------------------------------------------------------------------
%files
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%doc $RPM_BUILD_ROOT/doc/*
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/bin
%dir %{CFG_PREFIX}/doc
%{CFG_PREFIX}/bin/aflex
%{CFG_PREFIX}/bin/ayacc
#
#  ---------------------------------------------------------------------------
%clean
rm -rf $RPM_BUILD_ROOT
#
#  ---------------------------------------------------------------------------
%changelog
* Sat Mar 13 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Published as Release 3

* Mon Mar 08 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Improved package dependency description

* Sun Mar 07 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Published as Release 2

* Mon Mar 01 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Changed gnu-Ada directory name to plain "gnat".

* Sun Feb 28 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Published as Release 1

* Thu Feb 25 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Created
